(require "read-line.scm")

(define (extract-pre)
  (let* ((begin-pre "<PRE class=code")
         (end-pre "</PRE>")
         (n-begin (string-length begin-pre))
         (n-end (string-length end-pre))
         (n-total (+ n-begin n-end)))
    (letrec
      ((de-htmlize
         (lambda (s)
           (letrec
             ((remove-tags
                (lambda (x skip)
                  (cond ((null? x) '())
                    ((char=? #\< (car x))
                      (remove-tags (cdr x) #t))
                    ((char=? #\> (car x))
                      (remove-tags (cdr x) #f))
                    (skip (remove-tags (cdr x) #t))
                    (else (cons (car x)
                            (remove-tags (cdr x) #f))))))
              (entity->char
                (lambda (s)
                  (let ((s (list->string s)))
                    (cond ((string=? "lt" s) #\<)
                          ((string=? "gt" s) #\>)
                          ((string=? "amp" s) #\&)
                          ((string=? "nbsp" s) #\space)
                          (else (bottom (list 'entity->char s)))))))
              (decode-entities
                (lambda (x entity)
                  (cond ((null? x) '())
                    ((char=? #\& (car x))
                      (decode-entities (cdr x) '()))
                    ((and entity (char=? #\; (car x)))
                      (cons (entity->char (reverse entity))
                        (decode-entities (cdr x) #f)))
                    (entity
                      (decode-entities (cdr x)
                        (cons (car x) entity)))
                    (else (cons (car x)
                            (decode-entities (cdr x) #f)))))))
             (list->string
               (decode-entities
                 (remove-tags (string->list s) #f)
                 #f)))))
       (write-line
         (lambda (ln)
           (begin (display (de-htmlize ln))
                  (newline))))
       (header
         (lambda (n)
           (begin (display "; ----- Line ")
                  (display n)
                  (write-line " -----"))))
       (extract
         (lambda (ln pass n)
           (let ((k (if (string? ln) (string-length ln) 0)))
             (cond ((eof-object? ln) ln)
               ((and (> k n-total)
                     (string=? begin-pre (substring ln 0 n-begin))
                     (string=? end-pre (substring ln (- k n-end) k)))
                 (begin (header n)
                        (write-line ln)
                        (newline)
                        (extract (read-line) #f (+ 1 n))))
               ((and (>= k n-begin)
                     (string=? begin-pre (substring ln 0 n-begin)))
                 (begin (header n)
                        (write-line ln)
                        (extract (read-line) #t (+ 1 n))))
               ((and pass
                     (>= k n-end)
                     (string=? end-pre (substring ln 0 n-end)))
                 (begin (write-line end-pre)
                        (newline)
                        (extract (read-line) #f (+ 1 n))))
               (else (begin (if pass (write-line ln) #f)
                            (extract (read-line) pass (+ 1 n)))))))))
    (extract (read-line) #f 1))))

(define (copy-pre from to)
  (with-input-from-file from
    (lambda ()
      (with-output-to-file to
        extract-pre))))

(define (main)
  (extract-pre))
