/* Compile: cc -o mini mini.c -lsketchy */

#include <stdio.h>
#include <sketchy.h>

int main(void) {
	int n;

	if (sk_init(SK_DFL_NODES, SK_DFL_VCELLS)) {
		fprintf(stderr, "sk_init failed\n");
		exit(1);
	}
	if (sk_loadImage(SK_DFL_IMAGE)) {
		fprintf(stderr, "sk_loadImage failed\n");
		exit(1);
	}
	while (1) {
		SK_errFlag = 0;
		n = sk_read();
		if (n == sk_eof()) break;
		n = sk_eval(n);
		if (SK_errFlag) {
			sk_printError();
		}
		else {
			sk_pr("=> ");
			sk_print(n);
			sk_nl();
		}
	}
	sk_bye();
}
