/* Compile: cc -o user user.c -lsketchy */

#include <stdio.h>
#include <sketchy.h>

int foo(int n) {
	int	m;
	int	e;
	long	v;

	if (sk_args(n) != 1)
		return sk_error("foo: wrong number of args", n);
	m = sk_nthArg(n, 0);
	if (sk_typeof(m) != SK_TYPE_INTEGER)
		return sk_error("foo: not an integer", m);
	e = 0;
	v = sk_int(m, &e);
	if (e) return sk_error("foo: value too big", m);
	return sk_mkInteger(v/2);
}

int main(void) {
	int n;

	if (sk_init(SK_DFL_NODES, SK_DFL_VCELLS)) {
		fprintf(stderr, "sk_init failed\n");
		exit(1);
	}
	if (sk_loadImage(SK_DFL_IMAGE)) {
		fprintf(stderr, "sk_loadImage failed\n");
		exit(1);
	}
	sk_addUserPrim("foo", foo);
	while (1) {
		SK_errFlag = 0;
		n = sk_read();
		if (n == sk_eof()) break;
		n = sk_eval(n);
		if (SK_errFlag) {
			sk_printError();
		}
		else {
			sk_pr("=> ");
			sk_print(n);
			sk_nl();
		}
	}
	sk_bye();
}
